statelessrule("Notify user if comment contains @username", model.Event.BEFORE_FLUSH, function(ctx) {
  return safeCall(safeCall(ctx.issue,"added", ["comments"]),"isNotEmpty", [], false);
}, function(ctx) {
  var separators = " `!#%^&*()=[]{}:;'\"\\|,<>/?\n\r\t";
  var mentionedUsers = "";
  
  var myComment = safeCall(safeCall(ctx.issue,"added", ["comments"]),"first", []);
  var originalText = safeCall(myComment,"get", ["text"], null);
  var text = " " + strOp("lowerCase", originalText) + " ";
  
  var username = "";
  var user = ctx.loggedInUser;
  var index = -1;
  
  index = strOp("indexOf", text, "@");
  
  while(!equals(index, -1)) {
    index = index + 1;
    username = "";
    
    var nextSymbol = strOp("substring", text, index, index + 1);
    while(!strOp("contains", separators, nextSymbol)) {
      username = username + nextSymbol;
      index = index + 1;
      nextSymbol = strOp("substring", text, index, index + 1);
    }
    
    if (strOp("endsWith", username, ".")) {
      username = strOp("left", username, strOp("length", username) - 1);
    }
    
    log("debug", "Extracted @username: |" + username + "|", ctx);
    if (strOp("isNotEmpty", username)) {
      user = invoke(ctx, safeCall(ctx.issue,"get", ["project"]), "getUser", [username]);
      
      if (!equals(user, null) && !strOp("containsIgnoreCase", mentionedUsers, "@" + safeCall(user,"get", ["login"], null) + ",") && (invoke(ctx, user, "isInGroup", [safeCall(safeCall(ctx.issue,"get", ["permittedGroup"]),"get", ["name"], null)]) || equals(safeCall(ctx.issue,"get", ["permittedGroup"]), null) || equals(user, safeCall(ctx.issue,"get", ["reporter"]))) && (equals(safeCall(myComment,"get", ["permittedGroup"]), null) || invoke(ctx, user, "isInGroup", [safeCall(safeCall(myComment,"get", ["permittedGroup"]),"get", ["name"], null)]))) {
        invoke(ctx, user, "notify", [localize("Notify_user_if_comment_contains_@username._YouTrack_@Mention_{0}{1}", invoke(ctx, ctx.issue, "getId", []), safeCall(ctx.issue,"get", ["summary"], null)),localize("Notify_user_if_comment_contains_@username.<p_style_font-size_14px;_font-family_sans-serif;_color_#000000;_margin_14px_0_19px_44px_>You_were_mentioned_in_the_comment_by_<b>{0}</b>_in_project_{1}_at_{2}</p><table_style_border-collapse_collapse;_width_100%;_table-layout_fixed;_>_<tbody>_<tr>_<td_style_padding_12px_15px;_background_#f0f0f0_>_<table_style_border-collapse_collapse;_border_0;_width_100%;_>_<tbody>_<tr>_<td_style_vertical-align_top;_font-family_sans-serif;_font-size_13px;_><a_title_YouTrack_style_float_left;_margin-right_6px;_font-size_15px;_color_#1466c6;_text-decoration_none;_href_{3}_>{4}_</a>_<a_style_font-size_15px;_color_#1466c6;_text-decoration_none;_href_{5}_>{6}</a>_</td>_</tr>_</tbody>_</table>_</td>_</tr>_</tbody></table></p><table_style_width_100%;_border-collapse_collapse;_border_0;_><tr><td_style_padding_10px_0_10px_10px;_vertical-align_top;_font-family_sans-serif;_font-size_13px;_background_#f0f0f0;_border-top_8px_solid_#ffffff;_>{7}</td></tr></table><p_style_color_gray;font-size_12px;margin-top_1em;border-top_1px_solid_#D4D5D6_>You_<b>{8}</b>_received_this_message_because_you_ve_been_mentioned_in_the_comment_Sincerely_yours_YouTrack</p>", safeCall(safeCall(myComment,"get", ["author"]),"get", ["fullName"], null), safeCall(safeCall(ctx.issue,"get", ["project"]),"get", ["name"], null), formatDateTime(ctx, safeCall(myComment,"get", ["created"], 0), predefinedDateTimeFormat("mediumDateTime")), invoke(ctx, ctx.issue, "getUrl", []), invoke(ctx, ctx.issue, "getId", []), invoke(ctx, ctx.issue, "getUrl", []), safeCall(ctx.issue,"get", ["summary"], null), invoke(ctx, ctx.issue, "wikify", [originalText]), safeCall(user,"get", ["login"], null)),true]);
        mentionedUsers = mentionedUsers + "@" + safeCall(user,"get", ["login"], null) + ",";
      }
    }
    
    text = strOp("substringAfter", text, "@" + username);
    index = strOp("indexOf", text, "@");
  }
}).addRequirements(requirements([{name: "Issue", fields: [{name: "comments", type: {name: "IssueComment", multiple: true, fields: [{name: "text", type: {name: "string", primitive: true}}, {name: "author", type: {name: "User", fields: [{name: "fullName", type: {name: "string", primitive: true}}]}}, {name: "created", type: {name: "instant", primitive: true}}, {name: "permittedGroup", type: {name: "UserGroup", fields: [{name: "name", type: {name: "string", primitive: true}}]}}]}}, {name: "project", type: {name: "Project", fields: [{name: "name", type: {name: "string", primitive: true}}], methods: [{name: "getUser", returnType: {name: "User"}, paramTypes: [{name: "string"}]}]}}, {name: "summary", type: {name: "string", primitive: true}}, {name: "reporter", type: {name: "User"}}, {name: "permittedGroup", type: {name: "UserGroup", fields: [{name: "name", type: {name: "string", primitive: true}}]}}]}, {name: "User", fields: [{name: "login", type: {name: "string", primitive: true}}]}]));